Attribute VB_Name = "COOP"

Option Explicit

'When passing a user Type as a pointer to memory, you need to
'align the elements. Otherwise, the data may not be copied to the
'correct elements in Visual Basic. Refer to the "Visual Basic
'Programmer's Guide to the Win32 API" or some other Win32 reference
'book for further explanation on how Visual Basic handles Type alignments.
Type CoopStructure
    CompanyName(1 To 24) As Byte
    count As Integer
    dummy As Integer    'dummy integer to pad the structure, try removing
                        'this to see what happens
    Amount As Single
    Total As Long
End Type

Global Const COOP_MESSAGE = "Coop_Private_Message"
Global Const THUNDERRTMAIN = "ThunderRTMain"

#If Win32 Then
    Public Declare Sub dwCopyDataBynum Lib "dwspy32.dll" Alias "dwCopyData" (ByVal Source&, ByVal dest&, ByVal nCount&)
    Public Declare Function dwGetAddressForObject& Lib "dwspy32.dll" (object As Any)
    Public Declare Sub dwCopyDataByString Lib "dwspy32.dll" Alias "dwCopyData" (ByVal Source As String, ByVal dest As Long, ByVal nCount&)
    Public Declare Function dwXCopyDataBynumFrom& Lib "dwspy32.dll" Alias "dwXCopyDataFrom" (ByVal mybuf As Long, ByVal foreignbuf As Long, ByVal size As Integer, ByVal foreignPID As Long)
    Public Declare Function dwGetWndInstance& Lib "dwspy32.dll" (ByVal hWnd&)
    
    Public Declare Function RegisterWindowMessage& Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpstring As String)
    Public Declare Function GetWindowLong& Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long)
    Public Declare Function EnumWindows& Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long)
    Public Declare Function SendMessageBynum& Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    Public Declare Function GetWindowThreadProcessId& Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long)
    Public Declare Function GetClassName& Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long)
#Else

    Global Const GWW_HINSTANCE = -6
    
    Public Declare Sub dwCopyDataByString Lib "dwspydll.dll" Alias "dwCopyData" (ByVal Source As String, ByVal dest As Long, ByVal nCount%)
    Public Declare Sub dwCopyDataBynum Lib "dwspydll.dll" Alias "dwCopyData" (ByVal Source&, ByVal dest&, ByVal nCount%)
    Public Declare Function dwGetAddressForObject& Lib "dwspydll.dll" (object As Any)
    Public Declare Function dwGetAddressForVBString& Lib "dwspydll.dll" (vbstring$)

    Public Declare Function RegisterWindowMessage% Lib "User" (ByVal frmsgstr$)
    Public Declare Function EnumWindows% Lib "User" (ByVal lpEnumFunc&, ByVal lParam&)
    Public Declare Function GetWindowWord% Lib "User" (ByVal hWnd%, ByVal offset%)
    Public Declare Function SendMessage% Lib "User" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, lParam As Any)
    Public Declare Function SendMessageBynum& Lib "User" Alias "SendMessage" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, ByVal lParam&)
    Public Declare Function GetWindow% Lib "User" (ByVal hWnd%, ByVal wCmd%)
    Public Declare Function GetWindowTask% Lib "User" (ByVal hWnd%)
    Public Declare Function GetClassName% Lib "User" (ByVal hWnd%, ByVal lpstr$, ByVal strlen%)
    Public Declare Function GlobalAlloc% Lib "kernel" (ByVal wFlags%, ByVal dwBytes&)
    Public Declare Function GlobalLock& Lib "kernel" (ByVal hMem%)
    Public Declare Function GlobalUnlock% Lib "kernel" (ByVal hMem%)
    Public Declare Function GlobalFree% Lib "kernel" (ByVal hMem%)
    Public Declare Function lstrlen% Lib "kernel" (ByVal lp&)
#End If

